'use client'
import { useMutation } from '@tanstack/react-query'
import { toISOIfNotZ } from '@/lib/utils';
import { BuildSitesAdd } from './schema';

const fetchGraphQlBuildSitesAdd = async (record: BuildSitesAdd): Promise<{ data: BuildSitesAdd | null; status: number }> => {
    console.log('Fetching test data from local API');
    record.expiryStarts = record.expiryStarts ? toISOIfNotZ(record.expiryStarts) : undefined;
    record.expiryEnds = record.expiryEnds ? toISOIfNotZ(record.expiryEnds) : undefined;
    console.dir({ record })
    try {
        const res = await fetch('/api/build-sites/add', { method: 'POST', cache: 'no-store', credentials: "include", body: JSON.stringify(record) });
        if (!res.ok) { const errorText = await res.text(); console.error('Test data API error:', errorText); throw new Error(`API error: ${res.status} ${res.statusText}`) }
        const data = await res.json();
        return { data: data.data, status: res.status }
    } catch (error) { console.error('Error fetching test data:', error); throw error }
};

export function useAddBuildSitesMutation() {
    return useMutation({
        mutationFn: ({ data }: { data: BuildSitesAdd }) => fetchGraphQlBuildSitesAdd(data),
        onSuccess: () => { console.log("Build sites created successfully") },
        onError: (error) => { console.error("Add build sites failed:", error) },
    })
}
